/***
 * Condition variable test #3
 *
 * Change Log:
 * 2003/10/22 ghort	created
 * 2003/11/03 ghort	cleaned up and integrated
 * 2004/10/25 pallas	updated for new assignment specification
 * 2005/01/13 pallas	updated for user space API
 */

static char * desc =
	"Tests whether the timeout version of condition variables\n"
	"really does not block.\n";


#include <librt.h>
#include "../defs.h"


/*
 * Length of wait timeout on condition variable.
 */
#define CV_TIMEOUT_MS	2000


char *
test_condvar3 (void)
{
	struct mutex	mtx;
	struct cond	cond;

	printf (desc);

	// init
	mutex_init (& mtx);
	cond_init (& cond);


	/*
	 * Test the timeouts.
	 */
	mutex_lock (& mtx);

	printf ("Wait on condition variable for (approx.) 2 seconds...\n");
	cond_wait_timeout (& cond, & mtx, CV_TIMEOUT_MS * 1000);

	printf ("Wait on condition variable for (approx.) 4 seconds...\n");
	cond_wait_timeout (& cond, & mtx, 2 * CV_TIMEOUT_MS * 1000);


	// clean up
	cond_destroy (& cond);
	mutex_destroy (& mtx);
	
	return NULL;
} /* main */
