/***
 * Semaphore test #3
 *
 * Change Log:
 * 2003/10/22 ghort	created
 * 2004/10/25 pallas	updated for new assignment specification
 * 2005/01/13 pallas	updated for user space API
 */

static char * desc =
	"Tests whether the timeout version of semaphores really\n"
	"does not block.\n";


#include <librt.h>
#include "../defs.h"


/*
 * Length of down timeout on semaphore.
 */
#define SEM_TIMEOUT_MS	2000


char *
test_semaphore3 (void)
{
	int 			success;
	int			result;
	struct semaphore	sem;

	printf (desc);

	// init
	success = 1;
	sem_init (& sem, 0);


	/*
	 * Test the timeouts.
	 */
	printf ("Try down on semaphore for (approx.) 2 seconds...\n");
	result = sem_down_timeout (& sem, SEM_TIMEOUT_MS * 1000);
	success = (result == ETIMEDOUT) ? success : 0;

	printf ("Try down on semaphore for (approx.) 4 seconds...\n");
	result = sem_down_timeout (& sem, 2 * SEM_TIMEOUT_MS * 1000);
	success = (result == ETIMEDOUT) ? success : 0;


	// clean up
	sem_destroy (& sem);

	if (!success)
		return "Some of the operations did not return ETIMEDOUT";
	
	return NULL;
}
